---
title: WebGLRenderingContext.drawElements()
slug: Web/API/WebGLRenderingContext/drawElements
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.drawElements()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> renders primitives from array data.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.drawElements(<var>mode</var>, <var>count</var>, <var>type</var>, <var>offset</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>mode</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the type primitive to render. Possible values are:
 <ul>
  <li><code>gl.POINTS</code>: Draws a single dot.</li>
  <li><code>gl.LINE_STRIP</code>: Draws a straight line to the next vertex.</li>
  <li><code>gl.LINE_LOOP</code>: Draws a straight line to the next vertex, and connects the last vertex back to the first.</li>
  <li><code>gl.LINES</code>: Draws a line between a pair of vertices.</li>
  <li><code><a href="https://en.wikipedia.org/wiki/Triangle_strip">gl.TRIANGLE_STRIP</a></code></li>
  <li><code><a href="https://en.wikipedia.org/wiki/Triangle_fan">gl.TRIANGLE_FAN</a></code></li>
  <li><code>gl.TRIANGLES</code>: Draws a triangle for a group of three vertices.</li>
 </ul>
 </dd>
 <dt>count</dt>
 <dd>A {{domxref("GLsizei")}} specifying the number of elements to be rendered.</dd>
 <dt>type</dt>
 <dd>A {{domxref("GLenum")}} specifying the type of the values in the element array buffer. Possible values are:
 <ul>
  <li><code>gl.UNSIGNED_BYTE</code></li>
  <li><code>gl.UNSIGNED_SHORT</code></li>
  <li>When using the {{domxref("OES_element_index_uint")}} extension:
   <ul>
    <li><code>gl.UNSIGNED_INT</code></li>
   </ul>
  </li>
 </ul>
 </dd>
 <dt>offset</dt>
 <dd>A {{domxref("GLintptr")}} specifying a byte offset in the element array buffer. Must be a valid multiple of the size of the given <code>type</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>If <code>mode</code> is not one of the accepted values, a <code>gl.INVALID_ENUM</code> error is thrown.</li>
 <li>If <code>offset</code> is not a valid multiple of the size of the given type, a <code>gl.INVALID_OPERATION</code> error is thrown.</li>
 <li>If <code>count</code> is negative, a <code>gl.INVALID_VALUE</code> error is thrown.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.drawElements(gl.POINTS, 8, gl.UNSIGNED_BYTE, 0);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.11", "drawElements")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glDrawElements.xml", "glDrawElements")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.drawElements")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.drawArrays()")}}</li>
 <li>{{domxref("OES_element_index_uint")}}</li>
 <li>{{domxref("WEBGL_multi_draw.multiDrawElementsWEBGL()")}}</li>
</ul>
